package reborncore.common.blocks;

import java.util.ArrayList;
import java.util.List;
import java.util.Random;

import me.modmuss50.jsonDestroyer.api.IFakeTexturedBlock;
import me.modmuss50.jsonDestroyer.api.ITexturedBlock;
import net.minecraft.block.Block;
import net.minecraft.block.BlockDynamicLiquid;
import net.minecraft.block.BlockStaticLiquid;
import net.minecraft.block.material.Material;
import net.minecraft.block.properties.PropertyBool;
import net.minecraft.block.properties.PropertyDirection;
import net.minecraft.block.state.BlockStateContainer;
import net.minecraft.block.state.IBlockState;
import net.minecraft.entity.EntityLivingBase;
import net.minecraft.entity.EnumCreatureType;
import net.minecraft.entity.item.EntityItem;
import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemBlock;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.EnumFacing;
import net.minecraft.util.EnumHand;
import net.minecraft.util.math.BlockPos;
import net.minecraft.world.IBlockAccess;
import net.minecraft.world.World;
import net.minecraftforge.fluids.BlockFluidBase;
import net.minecraftforge.fluids.FluidContainerRegistry;
import net.minecraftforge.fluids.FluidStack;
import net.minecraftforge.fluids.IFluidContainerItem;
import net.minecraftforge.fluids.IFluidHandler;
import reborncore.common.BaseTileBlock;
import reborncore.common.tile.TileMachineBase;

public abstract class BlockMachineBase extends BaseTileBlock implements IFakeTexturedBlock
{

	public static PropertyDirection FACING = PropertyDirection.func_177712_a("facing", EnumFacing.Plane.HORIZONTAL);
	public static PropertyBool ACTIVE = PropertyBool.func_177716_a("active");

	public static ItemStack machineStack;
	public static ItemStack advancedMachineStack;

	public BlockMachineBase()
	{
		super(Material.field_151576_e);
		func_149711_c(2f);
		// setStepSound(soundTypeMetal); //TODO 1.9
		this.func_180632_j(
				this.field_176227_L.func_177621_b().func_177226_a(FACING, EnumFacing.NORTH).func_177226_a(ACTIVE, false));
	}

	protected BlockStateContainer func_180661_e()
	{

		FACING = PropertyDirection.func_177712_a("facing", EnumFacing.Plane.HORIZONTAL);
		ACTIVE = PropertyBool.func_177716_a("active");
		return new BlockStateContainer(this, FACING, ACTIVE);
	}

	@Override
	public TileEntity func_149915_a(World p_149915_1_, int p_149915_2_)
	{
		return new TileMachineBase();
	}

	@Deprecated
	public void onBlockAdded(World world, int x, int y, int z)
	{
	}

	@Override
	public void func_176213_c(World worldIn, BlockPos pos, IBlockState state)
	{
		super.func_176213_c(worldIn, pos, state);
		onBlockAdded(worldIn, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p());
		this.setDefaultFacing(worldIn, pos, state);
	}

	private void setDefaultFacing(World worldIn, BlockPos pos, IBlockState state)
	{
		if (!worldIn.field_72995_K)
		{
			IBlockState sate = worldIn.func_180495_p(pos.func_177978_c());
			Block block = sate.func_177230_c();
			IBlockState state1 = worldIn.func_180495_p(pos.func_177968_d());
			Block block1 = state1.func_177230_c();
			IBlockState state2 = worldIn.func_180495_p(pos.func_177976_e());
			Block block2 = state2.func_177230_c();
			IBlockState state3 = worldIn.func_180495_p(pos.func_177974_f());
			Block block3 = state3.func_177230_c();
			EnumFacing enumfacing = (EnumFacing) state.func_177229_b(FACING);

			if (enumfacing == EnumFacing.NORTH && block.func_149730_j(state) && !block1.func_149730_j(state1))
			{
				enumfacing = EnumFacing.SOUTH;
			} else if (enumfacing == EnumFacing.SOUTH && block1.func_149730_j(state1) && !block.func_149730_j(state))
			{
				enumfacing = EnumFacing.NORTH;
			} else if (enumfacing == EnumFacing.WEST && block2.func_149730_j(state2) && !block3.func_149730_j(state2))
			{
				enumfacing = EnumFacing.EAST;
			} else if (enumfacing == EnumFacing.EAST && block3.func_149730_j(state3) && !block2.func_149730_j(state2))
			{
				enumfacing = EnumFacing.WEST;
			}

			worldIn.func_180501_a(pos, state.func_177226_a(FACING, enumfacing), 2);
		}
	}

	@Deprecated
	public void onBlockPlacedBy(World world, int x, int y, int z, EntityLivingBase player, ItemStack itemstack)
	{

	}

	@Override
	public void func_180633_a(World worldIn, BlockPos pos, IBlockState state, EntityLivingBase placer,
			ItemStack stack)
	{
		super.func_180633_a(worldIn, pos, state, placer, stack);
		onBlockPlacedBy(worldIn, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p(), placer, stack);
		setFacing(placer.func_174811_aO().func_176734_d(), worldIn, pos);
	}

	public boolean canCreatureSpawn(EnumCreatureType type, World world, int x, int y, int z)
	{
		return false;
	}

	@Deprecated
	public void breakBlock(World world, int x, int y, int z, Block block, int meta)
	{

	}

	@Override
	public void func_180663_b(World worldIn, BlockPos pos, IBlockState state)
	{
		dropInventory(worldIn, pos);
		super.func_180663_b(worldIn, pos, state);
		breakBlock(worldIn, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p(), state.func_177230_c(), 0);
	}

	protected void dropInventory(World world, BlockPos pos)
	{
		TileEntity tileEntity = world.func_175625_s(pos);

		if (tileEntity == null)
		{
			return;
		}
		if (!(tileEntity instanceof IInventory))
		{
			return;
		}

		IInventory inventory = (IInventory) tileEntity;

		List<ItemStack> items = new ArrayList<ItemStack>();

		for (int i = 0; i < inventory.func_70302_i_(); i++)
		{
			ItemStack itemStack = inventory.func_70301_a(i);

			if (itemStack == null)
			{
				continue;
			}
			if (itemStack != null && itemStack.field_77994_a > 0)
			{
				if (itemStack.func_77973_b() instanceof ItemBlock)
				{
					if (((ItemBlock) itemStack.func_77973_b()).field_150939_a instanceof BlockFluidBase
							|| ((ItemBlock) itemStack.func_77973_b()).field_150939_a instanceof BlockStaticLiquid
							|| ((ItemBlock) itemStack.func_77973_b()).field_150939_a instanceof BlockDynamicLiquid)
					{
						continue;
					}
				}
			}
			items.add(itemStack.func_77946_l());
		}

		for (ItemStack itemStack : items)
		{
			Random rand = new Random();

			float dX = rand.nextFloat() * 0.8F + 0.1F;
			float dY = rand.nextFloat() * 0.8F + 0.1F;
			float dZ = rand.nextFloat() * 0.8F + 0.1F;

			EntityItem entityItem = new EntityItem(world, pos.func_177958_n() + dX, pos.func_177956_o() + dY, pos.func_177952_p() + dZ,
					itemStack.func_77946_l());

			if (itemStack.func_77942_o())
			{
				entityItem.func_92059_d().func_77982_d((NBTTagCompound) itemStack.func_77978_p().func_74737_b());
			}

			float factor = 0.05F;
			entityItem.field_70159_w = rand.nextGaussian() * factor;
			entityItem.field_70181_x = rand.nextGaussian() * factor + 0.2F;
			entityItem.field_70179_y = rand.nextGaussian() * factor;
			world.func_72838_d(entityItem);
			itemStack.field_77994_a = 0;
		}
	}

	@Override
	public List<ItemStack> getDrops(IBlockAccess world, BlockPos pos, IBlockState state, int fortune)
	{
		List<ItemStack> items = new ArrayList<ItemStack>();
		items.add(isAdvanced() ? advancedMachineStack.func_77946_l() : machineStack.func_77946_l());
		return items;
	}

	public boolean isAdvanced()
	{
		return false;
	}

	@Override
	public boolean rotateBlock(World world, BlockPos pos, EnumFacing axis)
	{
		if (axis == null)
		{
			return false;
		} else
		{
			TileEntity tile = world.func_175625_s(pos);
			if (tile != null && tile instanceof TileMachineBase)
			{
				TileMachineBase machineBase = (TileMachineBase) tile;
				// TODO fix
				// world.setBlockState(pos,
				// world.getBlockState(pos).withProperty(FACING,
				// EnumFacing.getFront(world.getBlockState(pos).getValue(FACING)).getOpposite()));
				return true;
			}
			return false;
		}
	}

	@Override
	public boolean func_180639_a(World worldIn, BlockPos pos, IBlockState state, EntityPlayer playerIn,
			EnumHand hand, ItemStack heldItem, EnumFacing side, float hitX, float hitY, float hitZ)
	{
		if (fillBlockWithFluid(worldIn, pos, playerIn))
		{
			return true;
		}
		if (onBlockActivated(worldIn, pos.func_177958_n(), pos.func_177956_o(), pos.func_177952_p(), playerIn, side.func_176745_a(), hitX, hitY, hitZ))
		{
			return true;
		}
		return super.func_180639_a(worldIn, pos, state, playerIn, hand, heldItem, side, hitX, hitY, hitZ);
	}

	@Deprecated
	public boolean onBlockActivated(World world, int x, int y, int z, EntityPlayer entityplayer, int side, float hitX,
			float hitY, float hitZ)
	{
		return false;
	}

	public boolean fillBlockWithFluid(World world, BlockPos pos, EntityPlayer entityplayer)
	{
		ItemStack current = entityplayer.field_71071_by.func_70448_g();

		if (current != null)
		{
			TileEntity tile = world.func_175625_s(pos);

			if (tile instanceof IFluidHandler)
			{
				IFluidHandler tank = (IFluidHandler) tile;
				// Handle FluidContainerRegistry
				if (FluidContainerRegistry.isContainer(current))
				{
					FluidStack liquid = FluidContainerRegistry.getFluidForFilledItem(current);
					// Handle filled containers
					if (liquid != null)
					{
						int qty = tank.fill(null, liquid, true);

						if (qty != 0 && !entityplayer.field_71075_bZ.field_75098_d)
						{
							if (current.field_77994_a > 1)
							{
								if (!entityplayer.field_71071_by
										.func_70441_a(FluidContainerRegistry.drainFluidContainer(current)))
								{
									entityplayer.func_71019_a(
											FluidContainerRegistry.drainFluidContainer(current), false);
								}

								entityplayer.field_71071_by.func_70299_a(entityplayer.field_71071_by.field_70461_c,
										consumeItem(current));
							} else
							{
								entityplayer.field_71071_by.func_70299_a(entityplayer.field_71071_by.field_70461_c,
										FluidContainerRegistry.drainFluidContainer(current));
							}
						}

						return true;

						// Handle empty containers
					} else
					{
						FluidStack available = tank.getTankInfo(null)[0].fluid;

						if (available != null)
						{
							ItemStack filled = FluidContainerRegistry.fillFluidContainer(available, current);

							liquid = FluidContainerRegistry.getFluidForFilledItem(filled);

							if (liquid != null)
							{
								if (!entityplayer.field_71075_bZ.field_75098_d)
								{
									if (current.field_77994_a > 1)
									{
										if (!entityplayer.field_71071_by.func_70441_a(filled))
										{
											return false;
										} else
										{
											entityplayer.field_71071_by.func_70299_a(
													entityplayer.field_71071_by.field_70461_c, consumeItem(current));
										}
									} else
									{
										entityplayer.field_71071_by.func_70299_a(
												entityplayer.field_71071_by.field_70461_c, consumeItem(current));
										entityplayer.field_71071_by
												.func_70299_a(entityplayer.field_71071_by.field_70461_c, filled);
									}
								}

								tank.drain(null, liquid.amount, true);

								return true;
							}
						}
					}
				} else if (current.func_77973_b() instanceof IFluidContainerItem)
				{
					if (current.field_77994_a != 1)
					{
						return false;
					}

					if (!world.field_72995_K)
					{
						IFluidContainerItem container = (IFluidContainerItem) current.func_77973_b();
						FluidStack liquid = container.getFluid(current);
						FluidStack tankLiquid = tank.getTankInfo(null)[0].fluid;
						boolean mustDrain = liquid == null || liquid.amount == 0;
						boolean mustFill = tankLiquid == null || tankLiquid.amount == 0;
						if (mustDrain && mustFill)
						{
							// Both are empty, do nothing
						} else if (mustDrain || !entityplayer.func_70093_af())
						{
							liquid = tank.drain(null, 1000, false);
							int qtyToFill = container.fill(current, liquid, true);
							tank.drain(null, qtyToFill, true);
						} else if (mustFill || entityplayer.func_70093_af())
						{
							if (liquid.amount > 0)
							{
								int qty = tank.fill(null, liquid, false);
								tank.fill(null, container.drain(current, qty, true), true);
							}
						}
					}

					return true;
				}
			}
		}
		return false;
	}

	public static ItemStack consumeItem(ItemStack stack)
	{
		if (stack.field_77994_a == 1)
		{
			if (stack.func_77973_b().hasContainerItem(stack))
			{
				return stack.func_77973_b().getContainerItem(stack);
			} else
			{
				return null;
			}
		} else
		{
			stack.func_77979_a(1);

			return stack;
		}
	}

	@Override
	public String getTextureNameFromState(IBlockState blockState, EnumFacing facing)
	{
		if (this instanceof IRotationTexture)
		{
			IRotationTexture rotationTexture = (IRotationTexture) this;
			if (getFacing(blockState) == facing)
			{
				return isActive(blockState) ? rotationTexture.getFrontOn() : rotationTexture.getFrontOff();
			}
			if (facing == EnumFacing.UP)
			{
				return rotationTexture.getTop();
			}
			if (facing == EnumFacing.DOWN)
			{
				return rotationTexture.getBottom();
			}
			return rotationTexture.getSide();
		}
		if (this instanceof IAdvancedRotationTexture)
		{
			IAdvancedRotationTexture advancedRotationTexture = (IAdvancedRotationTexture) this;
			if (getFacing(blockState) == facing)
			{
				return advancedRotationTexture.getFront(isActive(blockState));
			}
			if (facing == EnumFacing.UP)
			{
				return advancedRotationTexture.getTop(isActive(blockState));
			}
			if (facing == EnumFacing.DOWN)
			{
				return advancedRotationTexture.getBottom(isActive(blockState));
			}
			return advancedRotationTexture.getSide(isActive(blockState));
		}
		return "techreborn:blocks/machine/machine_side";
	}

	@Override
	public int func_176201_c(IBlockState state)
	{
		int facingInt = getSideFromEnum(state.func_177229_b(FACING));
		int activeInt = state.func_177229_b(ACTIVE) ? 0 : 4;
		return facingInt + activeInt;
	}

	@Override
	public IBlockState func_176203_a(int meta)
	{
		boolean active = false;
		int facingInt = meta;
		if (facingInt > 4)
		{
			active = true;
			facingInt = facingInt - 4;
		}
		EnumFacing facing = getSideFromint(facingInt);
		return this.func_176223_P().func_177226_a(FACING, facing).func_177226_a(ACTIVE, active);
	}

	public boolean isActive(IBlockState state)
	{
		return state.func_177229_b(ACTIVE);
	}

	public EnumFacing getFacing(IBlockState state)
	{
		return state.func_177229_b(FACING);
	}

	public void setFacing(EnumFacing facing, World world, BlockPos pos)
	{
		world.func_175656_a(pos, world.func_180495_p(pos).func_177226_a(FACING, facing));
	}

	public void setActive(Boolean active, World world, BlockPos pos)
	{
		EnumFacing facing = world.func_180495_p(pos).func_177229_b(FACING);
		IBlockState state = world.func_180495_p(pos).func_177226_a(ACTIVE, active).func_177226_a(FACING, facing);
		world.func_180501_a(pos, state, 3);
	}

	@Override
	public int amountOfStates()
	{
		return 9; // 0-3 off nsew, 4-8 on nsew
	}

	public EnumFacing getSideFromint(int i)
	{
		if (i == 0)
		{
			return EnumFacing.NORTH;
		} else if (i == 1)
		{
			return EnumFacing.SOUTH;
		} else if (i == 2)
		{
			return EnumFacing.EAST;
		} else if (i == 3)
		{
			return EnumFacing.WEST;
		}
		return EnumFacing.NORTH;
	}

	public int getSideFromEnum(EnumFacing facing)
	{
		if (facing == EnumFacing.NORTH)
		{
			return 0;
		} else if (facing == EnumFacing.SOUTH)
		{
			return 1;
		} else if (facing == EnumFacing.EAST)
		{
			return 2;
		} else if (facing == EnumFacing.WEST)
		{
			return 3;
		}
		return 0;
	}
}
