package reborncore.common.powerSystem;

import net.minecraft.item.Item;
import net.minecraft.item.ItemStack;
import reborncore.api.power.IEnergyInterfaceItem;
import reborncore.common.powerSystem.traits.BasePowerTrait;
import reborncore.common.powerSystem.traits.EUItemPowerTrait;
import reborncore.common.powerSystem.traits.RFItemPowerTrait;
import reborncore.jtraits.MixinFactory;

public abstract class PoweredItem
{

	public static Item createItem(Class itemClass) throws IllegalAccessException, InstantiationException
	{
		return (Item) MixinFactory
				.mixin(itemClass, BasePowerTrait.class, RFItemPowerTrait.class, EUItemPowerTrait.class).newInstance();
	}

	public static boolean canUseEnergy(double energy, ItemStack stack)
	{
		if (stack.func_77973_b() instanceof IEnergyInterfaceItem)
		{
			return ((IEnergyInterfaceItem) stack.func_77973_b()).canUseEnergy(energy, stack);
		} else
		{
			return false;
		}
	}

	public static double useEnergy(double energy, ItemStack stack)
	{
		if (stack.func_77973_b() instanceof IEnergyInterfaceItem)
		{
			return ((IEnergyInterfaceItem) stack.func_77973_b()).useEnergy(energy, stack);
		} else
		{
			return 0;
		}
	}

	public static void setEnergy(double energy, ItemStack stack)
	{
		if (stack.func_77973_b() instanceof IEnergyInterfaceItem)
		{
			((IEnergyInterfaceItem) stack.func_77973_b()).setEnergy(energy, stack);
		}
	}

	public static double getEnergy(ItemStack stack)
	{
		if (stack.func_77973_b() instanceof IEnergyInterfaceItem)
		{
			return ((IEnergyInterfaceItem) stack.func_77973_b()).getEnergy(stack);
		} else
		{
			return 0;
		}
	}

	public static double addEnergy(double energy, ItemStack stack)
	{
		if (stack.func_77973_b() instanceof IEnergyInterfaceItem)
		{
			return ((IEnergyInterfaceItem) stack.func_77973_b()).addEnergy(energy, stack);
		}
		return 0;
	}

	public static double getMaxPower(ItemStack stack)
	{
		if (stack.func_77973_b() instanceof IEnergyInterfaceItem)
		{
			return ((IEnergyInterfaceItem) stack.func_77973_b()).getMaxPower(stack);
		}
		return 0;
	}

}
