package reborncore.common.util;

import net.minecraft.entity.player.EntityPlayer;
import net.minecraft.inventory.IInventory;
import net.minecraft.item.ItemStack;
import net.minecraft.nbt.NBTTagCompound;
import net.minecraft.nbt.NBTTagList;
import net.minecraft.tileentity.TileEntity;
import net.minecraft.util.text.ITextComponent;
import net.minecraft.util.text.TextComponentString;
import net.minecraftforge.common.util.Constants;

public class Inventory implements IInventory
{

	private final ItemStack[] contents;
	private final String name;
	private final int stackLimit;
	private TileEntity tile;
	public boolean hasChanged = false;

	public Inventory(int size, String invName, int invStackLimit, TileEntity tileEntity)
	{
		contents = new ItemStack[size];
		name = invName;
		stackLimit = invStackLimit;
		this.tile = tileEntity;
	}

	@Override
	public int func_70302_i_()
	{
		return contents.length;
	}

	@Override
	public ItemStack func_70301_a(int slotId)
	{
		return contents[slotId];
	}

	@Override
	public ItemStack func_70298_a(int slotId, int count)
	{
		if (slotId < contents.length && contents[slotId] != null)
		{
			if (contents[slotId].field_77994_a > count)
			{
				ItemStack result = contents[slotId].func_77979_a(count);
				func_70296_d();
				hasChanged = true;
				return result;
			}
			ItemStack stack = contents[slotId];
			func_70299_a(slotId, null);
			hasChanged = true;
			return stack;
		}
		return null;
	}

	@Override
	public void func_70299_a(int slotId, ItemStack itemstack)
	{
		if (slotId >= contents.length)
		{
			return;
		}
		contents[slotId] = itemstack;

		if (itemstack != null && itemstack.field_77994_a > this.func_70297_j_())
		{
			itemstack.field_77994_a = this.func_70297_j_();
		}
		func_70296_d();
		hasChanged = true;
	}

	@Override
	public int func_70297_j_()
	{
		return stackLimit;
	}

	@Override
	public boolean func_70300_a(EntityPlayer entityplayer)
	{
		return true;
	}

	@Override
	public void func_174889_b(EntityPlayer player)
	{

	}

	@Override
	public void func_174886_c(EntityPlayer player)
	{

	}

	public void readFromNBT(NBTTagCompound data)
	{
		readFromNBT(data, "Items");
	}

	public void readFromNBT(NBTTagCompound data, String tag)
	{
		NBTTagList nbttaglist = data.func_150295_c(tag, Constants.NBT.TAG_COMPOUND);

		for (int j = 0; j < nbttaglist.func_74745_c(); ++j)
		{
			NBTTagCompound slot = nbttaglist.func_150305_b(j);
			int index;
			if (slot.func_74764_b("index"))
			{
				index = slot.func_74762_e("index");
			} else
			{
				index = slot.func_74771_c("Slot");
			}
			if (index >= 0 && index < contents.length)
			{
				func_70299_a(index, ItemStack.func_77949_a(slot));
			}
		}
		hasChanged = true;
	}

	public void writeToNBT(NBTTagCompound data)
	{
		writeToNBT(data, "Items");
	}

	public void writeToNBT(NBTTagCompound data, String tag)
	{
		NBTTagList slots = new NBTTagList();
		for (byte index = 0; index < contents.length; ++index)
		{
			if (contents[index] != null && contents[index].field_77994_a > 0)
			{
				NBTTagCompound slot = new NBTTagCompound();
				slots.func_74742_a(slot);
				slot.func_74774_a("Slot", index);
				contents[index].func_77955_b(slot);
			}
		}
		data.func_74782_a(tag, slots);
	}

	public void setTile(TileEntity tileEntity)
	{
		tile = tileEntity;
	}

	@Override
	public ItemStack func_70304_b(int slotId)
	{
		if (this.contents[slotId] == null)
		{
			return null;
		}

		ItemStack stackToTake = this.contents[slotId];
		func_70299_a(slotId, null);
		return stackToTake;
	}

	public ItemStack[] getStacks()
	{
		return contents;
	}

	@Override
	public boolean func_94041_b(int i, ItemStack itemstack)
	{
		return true;
	}

	// TODO find out what this is
	@Override
	public int func_174887_a_(int id)
	{
		return 0;
	}

	@Override
	public void func_174885_b(int id, int value)
	{

	}

	@Override
	public int func_174890_g()
	{
		return 0;
	}

	@Override
	public void func_174888_l()
	{

	}

	@Override
	public void func_70296_d()
	{
		tile.func_70296_d();
	}

	@Override
	public String func_70005_c_()
	{
		return name;
	}

	@Override
	public boolean func_145818_k_()
	{
		return false;
	}

	@Override
	public ITextComponent func_145748_c_()
	{
		return new TextComponentString(name);
	}
}
